{% extends 'base.html.twig' %}
{% import 'macro/_forms.html.twig' as macro %}
{% import 'macro/_sitting_tabs.html.twig' as macroTab %}
{% import 'macro/_sitting_nav.html.twig' as macroNav %}

{% block stylesheets %}
    {{ encore_entry_link_tags('vue-manage-projects') }}
{% endblock %}


{% block body %}

    <div class="col-12">
        {{ breadcrumbs() }}
    </div>


    <div v-cloak id="app">
        <div class="alert alert-success mt-2 col-11" v-if="messageInfo"> ${messageInfo}</div>
        <div class="alert alert-danger mt-2 col-11" v-if="messageError"> ${messageError}</div>

        <div class="mt-3 col-12">
            <div class="d-flex align-items-center">
                <h1 class="flex-grow-1">{{ title }}</h1>
                {{ macroNav.toogleView( path('sitting_show_projects', {'id': sitting.id}) , 'edit') }}
            </div>

            <div class="mt-4">
                {{ macro.backButton('sitting_index', {'status' : 'active'}) }}
            </div>

        </div>


        <div class="col-12  mt-4 px-3 form-white">
            {{ macroTab.editTabs('projects', sitting) }}

            {# Poids total #}
            <div class="col here mt-4 form-white">
                <div class="d-flex justify-content-end">

                    <p v-if="sittingTooBigForCreation === true" class="w-100 mx-0 alert alert-danger d-flex justify-content-between" >
                        <span><i class="fa fa-triangle-exclamation"></i> La séance ne pourra être enregistrée car le poids total dépasse le poids maximum autorisé de 2 Go. Veuillez réduire la taille ou le nombre de fichiers.</span>
                        <span> Poids total: ${formatSize(totalAllFileSize )}</span>
                    </p>
                    <p v-else-if="sittingTooBigForGeneration === true" class="w-100 mx-0 alert alert-warning d-flex justify-content-between" >
                        <span><i class="fa fa-triangle-exclamation"></i> Le PDF complet ainsi que le Zip de la séance ne seront pas générés car le poids total des fichiers dépasse 200 Mo  </span>
                        <span> Poids total: ${formatSize(totalAllFileSize)}</span>
                    </p>

                    <p v-else class="alert alert-success">Poids total:  ${formatSize(totalAllFileSize)}</p>
                </div>
                <div class="mt-4"></div>
            </div>


            {# autres documents #}
            <div class="d-flex justify-content-between">
                <label class="project-file-btn btn btn-primary" title="Ajouter des documents">
                    <input class="project-file-btn" type="file" accept=".pdf,.PDF" multiple @change="addOtherdoc($event)" onclick="this.value=null">
                    <span class="fa fa-plus-circle"></span> Ajouter des documents
                </label>

                <div class=" ml-auto d-flex justify-content-end mt-2">

                    <p v-if="documentFilesTooBig === true">
                        Poids des documents : <span class="text-warning"><i class="fa fa-triangle-exclamation"></i> ${formatSize(otherDocsFilesSize)}</span>
                    </p>
                    <p v-else><small> Poids des documents : <span class="text-success">${formatSize(otherDocsFilesSize)}  </span></small></p>
                </div>
            </div>

            <div class="mt-4"></div>

            <div v-if="otherdocs.length === 0" class="text-center">
                Aucun document associé
            </div>

            <draggable v-model="otherdocs" class="bg-white" @change="otherdocChange()" handle=".handle">

                <div v-for="(otherdoc, index) in otherdocs">
                    <div class="il-otherdoc">
                        <div style="padding: 20px" class="otherdoc-left cursor-grab handle">
                            <i class="fas fa-arrows-alt-v"></i>
                        </div>

                        <div class="otherdoc-right">
                            <div class="otherdoc-line">
                                <div class="otherdoc-item">
                                    <textarea v-model="otherdoc.name" ref="documentTitle" class="form-control" @change="otherdocChange()" @mouseleave="errorMsgTitleTooLong"> </textarea>
                                </div>
                                <div class="otherdoc-item d-flex justify-content-between">
                                    ${otherdoc.fileName}
                                    <span class="ml-5"><small> ${formatSize(otherdoc.size)}</small></span>

                                </div>

                                <div class="otherdoc-item action">
                                    <button class="btn btn-outline-danger borderless float-end"
                                            @click="removeOtherdoc(index)">
                                        <span class="fa fa-trash-alt" title="Supprimer"></span>
                                    </button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </draggable>

        </div>
        <div class="col-12 mt-4 px-3 form-white">

            <div class="d-flex justify-content-between">
                <label class="project-file-btn btn btn-primary" title="Ajouter des projets">
                    <input class="project-file-btn" type="file" accept=".pdf,.PDF" multiple @change="addProject($event)" onclick="this.value=null">
                    <span class="fa fa-plus-circle"></span> Ajouter des projets
                </label>
                <div class=" ml-auto d-flex justify-content-end mt-2">
                    <p v-if="projectFilesTooBig === true">
                        Poids des projets : <span class="text-warning"><i class="fa fa-triangle-exclamation"></i> ${formatSize(projectFilesSize)}</span>
                    </p>
                    <p v-else >
                        <small> Poids des projets : <span class="text-success">${formatSize(projectFilesSize)} </span></small>
                    </p>
                </div>
            </div>

            <div class="mt-4"></div>

            <div v-if="projects.length == 0" class="text-center">
                Aucun projet associé
            </div>

            <draggable v-model="projects" class="bg-white" @change="projectChange()" handle=".handle">

                <div v-for="(project, index) in projects">
                    <div class="il-project">
                        <div class="project-left cursor-grab handle">
                            <div class="dropdown">
                                <span class="badge bg-primary rank">${index + 1}</span>
                                <div class="dropdown-content">
                                    <div v-for="rank in projects.length" class="newRank" @click="move(index, rank -1)"> ${rank}</div>
                                </div>

                            </div>
                        </div>

                        <div class="project-right">
                            <div class="project-line">
                                <div class="project-item">
                                    <textarea v-model="project.name" class="form-control" @change="projectChange()" @mouseleave="errorMsgTitleTooLong"> </textarea>
                                </div>
                                <div class="project-item d-flex justify-content-between">
                                    ${project.fileName}
                                    <span class="ml-5"><small> ${formatSize(project.size)} </small></span>

                                </div>

                                <div class="project-item action">
                                    <button class="btn btn-outline-danger borderless float-end"
                                            @click="removeProject(index)">
                                        <span class="fa fa-trash-alt" title="Supprimer"></span>
                                    </button>
                                </div>

                            </div>

                            <div class="project-line">
                                <div class="project-item">
                                    <v-select v-bind:options="reporters"
                                              placeholder="Rapporteur"
                                              v-model="project.reporterId"
                                              :reduce="item => item.id"
                                              label="lastName"
                                              class="bs-form-like"
                                              :filter-by="reporterFilter"

                                    >
                                        <template #option="{ firstName, lastName }">
                                            ${ firstName } ${ lastName }
                                        </template>
                                        <template #selected-option="{ firstName, lastName }">
                                            ${ firstName } ${ lastName }
                                        </template>
                                        <span slot="no-options">
                                        Pas de résultats trouvés
                                    </span>
                                    </v-select>
                                </div>

                                <div class="project-item">
                                    <v-select v-bind:options="themes"
                                              placeholder="Thème"
                                              v-model="project.themeId"
                                              :reduce="item => item.id"
                                              label="fullName"
                                              class="bs-form-like">
                                        <template #option="{ levelName }">
                                            ${ levelName }
                                        </template>
                                        <template #selected-option="{ fullName }">
                                            ${ fullName }
                                        </template>
                                        <span slot="no-options">
                                        Pas de résultats trouvés
                                    </span>
                                    </v-select>
                                </div>

                                <div class="project-item action"></div>

                            </div>

                            <div class="project-line">
                                <div class="project-item">
                                    <label class="project-file-btn btn btn-outline-primary" title="Ajouter des annexes">
                                        <input class="project-file-btn" type="file" multiple @change="addAnnexes($event, project)">
                                        <span class="fa fa-plus-circle"></span> Ajouter des annexes
                                    </label>
                                </div>
                            </div>

                            <draggable v-model="project.annexes" @change="projectChange()" class="annex-list">
                                <div class="project-line annex cursor-grab" v-for="(annex, index) in project.annexes">
                                    <div class="badge bg-info ms-2 d-flex align-items-start" style="font-size: 1em">
                                        ${index + 1}
                                    </div>

                                    <div class="project-item" ref="annexTitleBlock">
                                        <textarea v-model="annex.title" ref="annexTitle" class="form-control" @change="annexChange()" @mouseleave="errorMsgTitleTooLong"> </textarea>
                                    </div>
                                    <div class="project-item d-flex justify-content-between">
                                        <div>
                                            ${annex.fileName}
                                        </div>
                                        <span class="ml-5"><small> ${formatSize(annex.size)} </small></span>
                                    </div>

                                    <div class="project-item action">
                                        <button class="btn btn-outline-danger borderless float-end"
                                                @click="deleteAnnex(project.annexes, index)">
                                            <span class="fa fa-trash-alt" title="Supprimer"></span>
                                        </button>
                                    </div>
                                </div>

                            </draggable>

                        </div>
                    </div>
                </div>
            </draggable>
        </div>

        <div class="float-end mt-5 mb-5">
            <button class="btn btn-link" @click="cancel()">
                <span class="fa fa-times"></span> Annuler Les modifications
            </button>


            <button v-if="sittingTooBigForCreation === true" class="btn btn-primary" id="save-sitting" disabled>
                <span class="fa fa-save"></span>
                Enregistrer les modifications
            </button>

            <button v-else class="btn btn-primary" @click="save()" id="save-sitting" ref="submitBtn">
                <span class="fa fa-save"></span>
                Enregistrer les modifications
            </button>



        </div>

        {# Modale #}
        <div v-if="showModal">
            <div name="modal">
                <div class="modal-mask">
                    <div class="modal-wrapper">
                        <div class="modal-dialog" role="document" style="width: 500px; height: 250px">
                            <div class="modal-content">
                                <div class="modal-body text-center">
                                    <div class=" display-2">
                                        <span class=" fas fa-spinner fa-spin text-primary"> </span>
                                    </div>
                                    <b class="display-4 text-primary"  v-if="uploadPercent < 100"> ${uploadPercent} %</b>
                                    <b class="fw-normal" style="font-size: 20px" v-else> Préparation de la séance en cours</b>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>


    {{ include('include/_modal_confirm_not_save.html.twig') }}


    <div><a id="cRetour" title="Retour en haut de page" class="cInvisible" href="#haut"></a></div>

{% endblock %}


{% block javascripts %}
    {{ encore_entry_script_tags('vue-manage-projects') }}
{% endblock %}

